import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * 
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Background extends greenfoot.World
{
    PointVector snowflakes[] = new PointVector[1500];
    public Background()
    {
        super(800, 800, 1);
        prepare();
    }
    
    private void prepare() {
        createSnow();
    }
    
    public void act() {
        for (int i=snowflakes.length-1; i>=0; i--) {
            PointVector flake = snowflakes[i];
            if (flake.getX() >= getWidth()-flake.rad-1 || flake.getY() >= getHeight()-flake.rad-1 || flake.getX() <= flake.rad-1 || flake.getY() <= flake.rad-1) {
                removeObject(flake);
                createFlake(i, 0.05);
            }
        }
    }

    public void createSnow() {
        for (int i=0; i<snowflakes.length; i++) {
            double z = dRandomInt(5, 95)/100.0;
            createFlake(i, z);
        }
    }
    
    public void createFlake(int i, double z) {
        int x = Greenfoot.getRandomNumber(getWidth());
        int y = Greenfoot.getRandomNumber(getHeight());
        PointVector flake = new PointVector(x, y, z);
        snowflakes[i] = flake;
        
        addObject(flake, x, y);
    }
    
    public int dRandomInt(int min, int max) {
        int n1 = Greenfoot.getRandomNumber(max)+min;
        int n2 = Greenfoot.getRandomNumber(max)+min;
        return Math.min(n1, n2);
    }
}
